// Simple telnet command without echo
// good for George3 console

import java.lang.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;

public class TeleType
       implements Runnable, WindowListener, KeyListener
{  private static TeleType listener = new TeleType();
   private static TextArea ttyRoll;
   private static InputStream fromServer;
   private static OutputStream toServer;
   private static boolean ttyEcho = true;

   public void run()
   // catches the server output and relays to the screen
   {  try
      {  byte[] ch = new byte[1];
         System.out.println("Listening to server");
         while  ( (ch[0] = (byte)fromServer.read()) >= 0 )
            ttyRoll.append(new String(ch));
         ttyRoll.append("\nConnection terminated");
         Thread.sleep(5000);
         System.out.println("Connection terminated");
         System.exit(0);
      }
      catch(Throwable x)
      {  x.printStackTrace();
      }
   }

   public static void main(String[] args)
   {  try
      {  int c;
         int port = 23;

         Frame f = new Frame("TeleType");
         f.setBounds(50, 50, 800, 800);
         ttyRoll = new TextArea(80,20);
         f.add(ttyRoll);
         ttyRoll.setVisible(true);
         f.setVisible(true);
         f.addWindowListener(listener);
         ttyRoll.addKeyListener(listener);
         ttyRoll.setEditable(false);
         ttyRoll.setBackground(Color.WHITE);
         ttyRoll.setFont(new Font("Monospaced", Font.PLAIN, 12));
         ttyRoll.setCursor(Cursor.getPredefinedCursor(Cursor.TEXT_CURSOR));

      // ttyRoll.append("First bit-");
      // ttyRoll.append("Second bit\n");

      // ttyRoll.append("Third bit-");
      // ttyRoll.append("Fourth bit\n");

         if  ( args.length >= 2 )
         {  ttyEcho = false;
            port = Integer.parseInt(args[1]);
         }
         Socket server = new Socket(args[0], port);
         fromServer = server.getInputStream();
         toServer = server.getOutputStream();
         new Thread(listener).run();

         while  ( (c = System.in.read()) != '!' )
            System.out.println((int) c);
      }
      catch(Throwable x)
      {  x.printStackTrace();
      }
   }

// Listener stuff

// KeyListener
   public void keyPressed(KeyEvent e)
   // Invoked when a key has been pressed.
   {  int wc = e.getKeyCode();
   // try
   // {
      // System.out.println(" keyPressed: keyCode = " + wc + "   keyChar = " + e.getKeyChar());
      // ttyRoll.append("Fourth bit\n");
   // }
   // catch(IOException x)
   // {  x.printStackTrace();
   // }
   }

   public void keyReleased(KeyEvent e)
   //      Invoked when a key has been released.
   {
   }
   
   private char[] keyChar = new char[1];

   public void keyTyped(KeyEvent e)
   //      Invoked when a key has been typed.
   {  try
      {  char wc = e.getKeyChar();
      // ttyRoll.append("Key typed " + wc + "\n");
         toServer.write((byte)wc);
         toServer.flush();
         if  ( ttyEcho )
         {  keyChar[0] = wc;
            ttyRoll.append(new String(keyChar));
         }
      }
      catch(Throwable x)
      {  x.printStackTrace();
      }
   }



// public interface java.awt.event.WindowListener
   public void windowOpened(WindowEvent e)
   {
   }
   public void windowClosing(WindowEvent e)
   {
   }
   public void windowClosed(WindowEvent e)
   {
   }
   public void windowIconified(WindowEvent e)
   {
   }
   public void windowDeiconified(WindowEvent e)
   {  System.out.println("redrawn");
      ttyRoll.requestFocusInWindow();
   }
   public void windowActivated(WindowEvent e)
   {
      ttyRoll.requestFocusInWindow();
   }
   public void windowDeactivated(WindowEvent e)
   {
   }

}
