/* This exports routines ftp_copy_file, ftp_connect and nfs_copy_file
   which perform overlapped copy operations between client
   filesystems and the archiver
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <time.h>

#define  SHUT_WR  1
#define  BUFFSZ  8192

#ifndef O_BINARY
#define  O_BINARY  0
#endif

int verbose = 1;

void tperror(char *s1, char *s2)
{  char b[400];
   sprintf(b, "%s: %s", s1, s2);  perror(b);
}

get_connected(char *target_thost, unsigned short target_tport)
{  int conskt = -1;
   int n;
   struct sockaddr_in target_end_addr;
   struct in_addr target_address;

   struct hostent *he;
   he = gethostbyname(target_thost);
   memcpy(&target_address.s_addr, *(he->h_addr_list), sizeof(target_address.s_addr));
   
   memset((char *) &target_end_addr, 0, sizeof(target_end_addr));
   target_end_addr.sin_family      = PF_INET;
   target_end_addr.sin_addr        = target_address;   /* .s_addr */
   target_end_addr.sin_port        = htons(target_tport);
   
   if  ( verbose >= 2 )
      printf("Creating Socket\n");

   conskt = socket(AF_INET, SOCK_STREAM, 0);
   if  (conskt < 0)
   {  fprintf(stdout, "Socket failed. errno = %d.\n", errno);
      fprintf(stdout, "No direct connect tcp socket\n");
      return;
   }
   
   if  ( verbose >= 2 )
      printf("Socket %d\n", conskt);

/* if  ( set_options(conskt) < 0 )
   {  fprintf(stdout, "can't set socket option(s)\n");
      return (-1);
   }
 */
   if  (connect( conskt, (struct sockaddr *)&target_end_addr, sizeof(target_end_addr)) < 0)
   {  fprintf(stdout, "Connect failed. errno = %d.\n", errno);
   }

   if  ( verbose >= 2 )
      printf("Connection complete\n");

   n = sizeof(target_end_addr);
   if  ( getsockname(conskt, (struct sockaddr *)&target_end_addr, &n) < 0 )
      perror("getsockname");
   else if  ( verbose >= 2 )
      printf("IP num at this end: %s\n", inet_ntoa(target_end_addr.sin_addr));

   return (conskt);
}


char header[] = "POST /UPLOAD/zhilary HTTP/1.0\r\nContent-type: multipart/fancy\r\nContent-length: %d\r\n";
char boundary[] = "\r\nasdflkjertoiuqwepoi\r\n";
char header2[] = "Content-Type: application/ms-word\r\nContent-Disposition: in-line; filename=\"temp.doc\"\r\n\r\n";
char buff[BUFFSZ+1];
char v2[] = "FILE %s\nmtime: %ld\ncmd: start\n\n";
char undo[] = "UNDO %s\n\n";

main(int argc, char **argv)
{  int fskt = get_connected("desk", 9090);
   struct stat file_gen;
   char *fn;
   int i, n, fin, fdiag;
   FILE *ttt = stdout;
   struct stat filegen;

   i = 0;

   if  ( argc < 2 )
      strcpy(buff, "parameter missing\n");

   else
   {  fn = argv[1];
      i = 0;
      n = strlen(fn);
      while  ( ++i < n  &&  memcmp(fn+i, "\\HEH\\", 5) != 0 ) ;

      if  ( i >= n )             // not from hilary's drag and drop
         i = -5;

      fprintf(ttt, "Start\n");

      if  ( argc > 2  &&  i >= 0 )    // undo previous HEH request
      {  sprintf(buff, undo, fn+i+5);
         fprintf(ttt, "Restoring file %s\n", fn+i);
         fprintf(ttt, "Command %s\n", buff);
         write(fskt, buff, strlen(buff));
      }
      else if  ( stat(fn, &file_gen) < 0 )
         fprintf(ttt, "Not found %s\n", fn);
      else if  ( (fin = open(fn, O_RDONLY + O_BINARY)) < 0 )
         fprintf(ttt, "Could not open %s\n", fn);
      else
      {  if  ( i >= n )
            fprintf(ttt, "Bad parameter %s\n", fn);
         else
         {  sprintf(buff, v2, fn+i+5, file_gen.st_mtime);
            fprintf(ttt, "Sending file %s\n", fn+i);
            fprintf(ttt, "Command %s\n", buff);
            write(fskt, buff, strlen(buff));
            while  ( (n = read(fin, buff, BUFFSZ)) > 0 )
               write(fskt, buff, n);
         }
         close(fin);
      }
   }
   
   shutdown(fskt, SHUT_WR);

   if  ( i == -5 )          // not drag and drop
   {  while  ( (n = read(fskt, buff, BUFFSZ)) > 0 )
      {  buff[n] = 0;
         printf("%s", buff, n);
      }
      printf("\nFile transfered was %s\n", fn);
      write(fdiag, argv[1], strlen(argv[1]));
      close(fskt);
   }
   else                     // drag and drop - write diagnostic file
   {  fdiag = open("C:/temp/temp.txt", O_WRONLY + O_CREAT + O_TRUNC + O_BINARY);
      while  ( (n = read(fskt, buff, BUFFSZ)) > 0 )
         write(fdiag, buff, n);
      write(fdiag, "\r\n\r\nFile transfered was ", 24);
      write(fdiag, argv[1], strlen(argv[1]));
      write(fdiag, "\r\n", 2);
      close(fdiag);
      close(fskt);
      fprintf(ttt, "Finished\n");
      system("start notepad C:\\\\temp\\\\temp.txt");
   }

   exit(0);
}

